/************************************************************************************************

 Author        : ADI - Apps            www.analog.com/AduC7060

 Date          : November 2007

 File          : SPI_Slave.c

 Hardware      : ADuC706x

 Description   : This SPI Slave example shows how to initialise the SPI peripheral in Slave mode.

		
*************************************************************************************************/
#include<aduc7060.h>

// Bit Definitions
#define BIT0  0x01
#define BIT1  0x02
#define BIT2  0x04
#define BIT3  0x08
#define BIT4  0x10
#define BIT5  0x20
#define BIT6  0x40
#define BIT7  0x80
#define BIT8  0x100
#define BIT9  0x200
#define BIT10 0x400
#define BIT11 0x800
#define BIT12 0x1000
#define BIT13 0x2000
#define BIT14 0x4000
#define BIT15 0x8000
#define BIT16 0x10000
#define BIT17 0x20000

unsigned char szStoreData[] = {0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55, 0x55};	// Array to send to Slave
unsigned char ucStoreCount = 0;  // Array index variable for szStoreData[]
unsigned char ucWaitingForXIRQ0 = 1; // Flag to begin write from Slave - controlled by XIRQ0
unsigned char ucReadOnly = 0;
unsigned char ucTxCnt = 0;
unsigned char ucbuffer = 0;

void delay(int);
int main(void)
{
    POWKEY1 = 0x1;
	POWCON0 = 0x78;		   // Set core to max CPU speed of 10.24Mhz
	POWKEY2 = 0xF4;
	// Configure P0.0, P0.1,P0.2 and P0.3 for SPI mode
	GP0CON0 = BIT0 + BIT4 + BIT8 + BIT12; // Select SPI/I2C alternative function for P0[0...3]
	GP0KEY1 = 0x7;		   //Write to GP0KEY1
	GP0CON1	= 0x00;	   // Select SPI functionality for P0.0 to  P0.3
	GP0KEY2 = 0x13;		   //Write to GP0KEY2

	// Enable SPI Slave mode and interrupt sources
	SPICON = BIT0    // Enable SPI 
		   + BIT7   // Clk pulses high at start of each bit + Initiate transfer on write to Tx FIFO
		   + BIT9	// MISO Output enable
	//	   + BIT4	// open drain mode on MISO
	//	   + BIT2
	//	   + BIT8	// Enable Rx FIFO overflow-overwrite
		   + BIT11//;		   //Continuous transfer mode + Enable IRQ on 1 byte transfer
		 //  + BIT14
		   + BIT15;

	ucStoreCount = 0;
	while ((SPISTA & BIT6) != BIT6){}
	szStoreData[ucStoreCount++] = SPIRX;
	szStoreData[ucStoreCount++] = SPIRX;
	szStoreData[ucStoreCount++] = SPIRX;
	while ((SPISTA & BIT6) != BIT6){}
	szStoreData[ucStoreCount++] = SPIRX;
	szStoreData[ucStoreCount++] = SPIRX;
	szStoreData[ucStoreCount++] = SPIRX;
	ucStoreCount = 0;
	delay (100);
	SPITX = szStoreData[ucStoreCount++];
	SPITX = szStoreData[ucStoreCount++];
	SPITX = szStoreData[ucStoreCount++];
	while ((SPISTA & BIT6) != BIT6){}	
    SPITX = szStoreData[ucStoreCount++];
	SPITX = szStoreData[ucStoreCount++];
	SPITX = szStoreData[ucStoreCount++];
	
	while ((SPISTA & BIT6) != BIT6){}	
 //   SPITX = szStoreData[ucStoreCount++];
//	SPITX = szStoreData[ucStoreCount++];
//	SPITX = szStoreData[ucStoreCount++];
	while (1){}

   return 0x00;
}

void IRQ_Handler(void) __irq
{



}
// Simple Delay routine
void delay (int length)
{
	while (length >0)
    	length--;
}

